/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* native mthods for handle holder */

#include <stdio.h>	/* for NULL */

#include <native.h>	/* for native methods */

#include "moba.h"	/* for find_method...() */


#define HOLDER_CLASSNAME "NET/shudo/moba/lang/GlobalReference"
#define REGISTER_SIGNATURE	"(Ljava/lang/Object;)V"
#define REGISTER_METHOD		"register"
#define	REMOVE_SIGNATURE	"(Ljava/lang/Object;)Ljava/lang/Object;"
#define REMOVE_METHOD		"remove"
#define RESET_SIGNATURE		"()V"
#define RESET_METHOD		"reset"


/*
 * Variables
 */

ClassClass *holderClazz = NULL;


/*
 * ֥Ȥơ֥Ͽ롣
 */
void registerGlobalHandle(HObject *obj) {
  static struct methodblock *method = NULL;
  ExecEnv *ee = EE();

  if (!holderClazz)
    holderClazz = FindClass(ee, HOLDER_CLASSNAME, TRUE);
  if (!method) {
    method = find_method_in_class(ee, holderClazz,
			REGISTER_METHOD, REGISTER_SIGNATURE);
    if (!method || exceptionOccurred(ee)) {
      /* not reached */
      printf("method " REGISTER_METHOD " is not found.\n");  fflush(stdout);
      return;
    }
  }

#if 0
  execute_java_static_method(ee, holderClazz,
			REGISTER_METHOD, REGISTER_SIGNATURE, obj);
#endif
  if (java_monitor) {
    struct methodblock *caller;
    long start_time, end_time;
    start_time = now();
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
    end_time = now();
    caller = calleeByInvokeOpcode(
	ee->current_frame->current_method, ee->current_frame->lastpc);
    if (!caller)  caller = ee->current_frame->current_method;
    java_mon(caller, method, end_time-start_time);
  }
  else {
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
  }
#ifdef DEBUG
  if (exceptionOccurred(ee)) {
    printf("Exception occurred in registerGlobalHandle().\n");
    fflush(stdout);

    exceptionDescribe(ee);
  }
#endif
}


/*
 * ֥Ȥơ֥뤫롣
 */
void removeGlobalHandle(HObject *obj) {
  static struct methodblock *method = NULL;
  ExecEnv *ee = EE();

  if (!holderClazz)
    holderClazz = FindClass(ee, HOLDER_CLASSNAME, TRUE);
  if (!method) {
    method = find_method_in_class(ee, holderClazz,
			REMOVE_METHOD, REMOVE_SIGNATURE);
    if (!method || exceptionOccurred(ee)) {
      /* not reached */
      printf("method " REMOVE_METHOD " is not found.\n");  fflush(stdout);
      return;
    }
  }

#if 0
  execute_java_static_method(ee, holderClazz,
			REMOVE_METHOD, REMOVE_SIGNATURE, obj);
#endif
  if (java_monitor) {
    struct methodblock *caller;
    long start_time, end_time;
    start_time = now();
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
    end_time = now();
    caller = calleeByInvokeOpcode(
	ee->current_frame->current_method, ee->current_frame->lastpc);
    if (!caller)  caller = ee->current_frame->current_method;
    java_mon(caller, method, end_time-start_time);
  }
  else {
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
  }
#ifdef DEBUG
  if (exceptionOccurred(ee)) {
    printf("Exception occurred in removeGlobalHandle().\n");
    fflush(stdout);

    exceptionDescribe(ee);
  }
#endif
}


/*
 * ơ֥ˤ롣
 */
void resetGlobalHandle(HObject *obj) {
  static struct methodblock *method = NULL;
  ExecEnv *ee = EE();

  if (!holderClazz)
    holderClazz = FindClass(ee, HOLDER_CLASSNAME, TRUE);
  if (!method) {
    method = find_method_in_class(ee, holderClazz,
			RESET_METHOD, RESET_SIGNATURE);
    if (!method || exceptionOccurred(ee)) {
      /* not reached */
      printf("method " RESET_METHOD " is not found.\n");  fflush(stdout);
      return;
    }
  }

#if 0
  execute_java_static_method(ee, holderClazz,
			RESET_METHOD, RESET_SIGNATURE, obj);
#endif
  if (java_monitor) {
    struct methodblock *caller;
    long start_time, end_time;
    start_time = now();
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
    end_time = now();
    caller = calleeByInvokeOpcode(
	ee->current_frame->current_method, ee->current_frame->lastpc);
    if (!caller)  caller = ee->current_frame->current_method;
    java_mon(caller, method, end_time-start_time);
  }
  else {
    do_execute_java_method(ee, holderClazz,
			0, 0, method, 1, /*arg*/ obj, NULL);
  }
#ifdef DEBUG
  if (exceptionOccurred(ee)) {
    printf("Exception occurred in resetGlobalHandle().\n");
    fflush(stdout);

    exceptionDescribe(ee);
  }
#endif
}
