/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* native methods for MetaField */

#include <stdio.h>	/* for NULL */
#include <string.h>	/* for strlen(), strcmp() */

#include <native.h>	/* for native methods */

#include "NET_shudo_moba_reflect_MetaField.h"
#include "NET_shudo_moba_reflect_MetaClass.h"

#include "moba.h"


/*
 * Local Functions
 */
static char *metafield_name(HNET_shudo_moba_reflect_MetaField *mf);
static char *metafield_signature(HNET_shudo_moba_reflect_MetaField *mf);
static unsigned short metafield_access(HNET_shudo_moba_reflect_MetaField *mf);
static char *field_name(ClassClass *, int32_t);
static char *field_signature(ClassClass *, int32_t);
static unsigned short field_access(ClassClass *, int32_t);

static void *value_ptr(HObject *obj, HNET_shudo_moba_reflect_MetaField *_this);


extern struct Hjava_lang_String *NET_shudo_moba_reflect_MetaField_name(struct HNET_shudo_moba_reflect_MetaField *_this) {
  char *name = metafield_name(_this);
  return makeJavaString(name, strlen(name));
}

extern struct Hjava_lang_String *NET_shudo_moba_reflect_MetaField_sig(struct HNET_shudo_moba_reflect_MetaField *_this) {
  char *sig = metafield_signature(_this);
  return makeJavaString(sig, strlen(sig));
}

extern int32_t NET_shudo_moba_reflect_MetaField_access(struct HNET_shudo_moba_reflect_MetaField *_this) {
  return (int32_t)metafield_access(_this);
}

extern /*boolean*/ int32_t NET_shudo_moba_reflect_MetaField_isAccessible(struct HNET_shudo_moba_reflect_MetaField *_this) {
  ClassClass *cb = HMetaClassToClassClass(_this);
  struct fieldblock *fb;
  uint16_t access;

  fb = cbFields(cb) + (unhand(_this)->index);
  access = fb->access;

  if ((access & ACC_STATIC) || (access & ACC_TRANSIENT)) {
    return FALSE;
  }
  else {
    return TRUE;
  }
}


/*
 * եɤͤ null ɤĴ٤롣
 */
extern /*boolean*/ int32_t NET_shudo_moba_reflect_MetaField_isValueNull(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return (value_ptr(obj, _this) == NULL);
}

/*
 * ܷΥեɤͤ
 */

extern char NET_shudo_moba_reflect_MetaField_getByteValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((char *)value_ptr(obj, _this));
}

extern unicode NET_shudo_moba_reflect_MetaField_getCharValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((unicode *)value_ptr(obj, _this));
}

extern double NET_shudo_moba_reflect_MetaField_getDoubleValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  double value;
  memcpy(&value, value_ptr(obj, _this), sizeof(double));
  return value;
}

extern float NET_shudo_moba_reflect_MetaField_getFloatValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((float *)value_ptr(obj, _this));
}

extern int32_t NET_shudo_moba_reflect_MetaField_getIntValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((int32_t *)value_ptr(obj, _this));
}

extern int64_t NET_shudo_moba_reflect_MetaField_getLongValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  int64_t value;
  memcpy(&value, value_ptr(obj, _this), sizeof(int64_t));
  return value;
}

extern short NET_shudo_moba_reflect_MetaField_getShortValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((short *)value_ptr(obj, _this));
}

extern /*boolean*/ int32_t NET_shudo_moba_reflect_MetaField_getBooleanValue(struct HNET_shudo_moba_reflect_MetaField *_this,struct Hjava_lang_Object *obj) {
  return *((int32_t *)value_ptr(obj, _this));
}

extern struct Hjava_lang_Object *NET_shudo_moba_reflect_MetaField_getObjectValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj) {
  void *ptr = value_ptr(obj, _this);
#ifdef DEBUG
  printf("MetaField#getObjectValue(): 0x%x\n", (int)ptr);
  fflush(stdout);
#endif

#if (JDK_VER < 110)
  /* JDK 1.0 ˤƤ static final String  field ̰ */
  {
    int access = metafield_access(_this);
    char *sig = metafield_signature(_this);
#ifdef DEBUG
    printf("signature, access: `%s', 0x%x\n", sig, access);
    fflush(stdout);
#endif
    if ((access & ACC_STATIC) && (access & ACC_VALKNOWN) &&
	(!strcmp(sig, "Ljava/lang/String;"))) {
		/* This field is "static final String" */
      unsigned int utf8index;
      ClassClass *cb;
      cp_item_type *constantPool;
      char *utf8str;

      utf8index = *(int *)ptr;
		/* pointer ǤϤʤ CP  index */
#ifdef DEBUG
      printf("index of (static final String) in CP: %d\n", utf8index);
      fflush(stdout);
#endif
      cb = HMetaClassToClassClass(_this);
      constantPool = cbConstantPool(cb);
      utf8str = constantPool[utf8index].cp;

      return (HObject *)makeJavaString(utf8str, strlen(utf8str));
    }
  }
#endif /* JDK_VER < 110 */

  return *((HObject **)ptr);
}

/*
 * եɤͤ򥻥åȤ
 */

extern void NET_shudo_moba_reflect_MetaField_setByteValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, char val) {
  *((char *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setCharValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, unicode val) {
  *((unicode *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setDoubleValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, double val) {
  memcpy(value_ptr(obj, _this), &val, sizeof(double));
}

extern void NET_shudo_moba_reflect_MetaField_setFloatValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, float val) {
  *((float *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setIntValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, int32_t val) {
  *((int32_t *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setLongValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, int64_t val) {
  memcpy(value_ptr(obj, _this), &val, sizeof(int64_t));
}

extern void NET_shudo_moba_reflect_MetaField_setShortValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, short val) {
  *((short *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setBooleanValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, /*boolean*/ int32_t val) {
  *((int32_t *)value_ptr(obj, _this)) = val;
}

extern void NET_shudo_moba_reflect_MetaField_setObjectValue(struct HNET_shudo_moba_reflect_MetaField *_this, struct Hjava_lang_Object *obj, struct Hjava_lang_Object * val) {
  *((HObject **)value_ptr(obj, _this)) = val;
}


/*
 *	Local Functions
 */

static char *metafield_name(struct HNET_shudo_moba_reflect_MetaField *mf) {
  ClassClass *cb = HMetaClassToClassClass(mf);
  return field_name(cb, unhand(mf)->index);
}

static char *metafield_signature(struct HNET_shudo_moba_reflect_MetaField *mf) {
  ClassClass *cb = HMetaClassToClassClass(mf);
  return field_signature(cb, unhand(mf)->index);
}

static unsigned short metafield_access(struct HNET_shudo_moba_reflect_MetaField *mf) {
  ClassClass *cb = HMetaClassToClassClass(mf);
  return field_access(cb, unhand(mf)->index);
}

static char *field_name(ClassClass *cb, int32_t index) {
  struct fieldblock *fb;

  fb = cbFields(cb) + index;
  return fieldname(fb);
}

static char *field_signature(ClassClass *cb, int32_t index) {
  struct fieldblock *fb;

  fb = cbFields(cb) + index;
  return fieldsig(fb);
}

static unsigned short field_access(ClassClass *cb, int32_t index) {
  struct fieldblock *fb;

  fb = cbFields(cb) + index;
  return fb->access;
}


static void *value_ptr(HObject *obj, HNET_shudo_moba_reflect_MetaField *_this) {
  ClassClass *cb = HMetaClassToClassClass(_this);
  int32_t index;
  struct fieldblock *fb;
  uint16_t access;

  fb = cbFields(cb) + (unhand(_this)->index);
  access = fb->access;

  if (access & ACC_STATIC) {
    char *sig = fb->signature;
#ifdef DEBUG
    printf("value_ptr(): field is static.\n", sig[0]);
    if (sig[0] == SIGNATURE_CLASS /* 'L' */) {	/* class */
      printf("value_ptr(): signature is `%s'\n", sig);
    }
    fflush(stdout);
#endif
    if ((sig[0] == SIGNATURE_DOUBLE) || (sig[0] == SIGNATURE_LONG)) {
      /* 64 bit data */
      return (char *)twoword_static_address(fb);
    }
    else {
      /* 32 bit data */
      return (char *)normal_static_address(fb);
    }
  }
  else {
    return ((char *)unhand(obj)) + fb->u.offset;
  }
}
