/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* native methods for MetaMethod */

#include <string.h>	/* for strlen() */

#include <native.h>	/* for native methods */

#include "NET_shudo_moba_reflect_MetaMethod.h"

#include "moba.h"


/*
 * Local Functions
 */
static struct methodblock *metaMethodToMethodblock(
			HNET_shudo_moba_reflect_MetaMethod *mm);


/*
 * ᥽åɤƤ
 */
extern void NET_shudo_moba_reflect_MetaMethod_invoke(struct HNET_shudo_moba_reflect_MetaMethod *_this, struct Hjava_lang_Object *obj, HArrayOfObject *hargs) {
  ExecEnv *ee = EE();
  struct methodblock *mb = metaMethodToMethodblock(_this);
  int isStaticCall = mb->fb.access & ACC_STATIC;
  int isNativeMethod = mb->fb.access & ACC_NATIVE;

  JavaFrame *newFrame, *oldFrame;
  stack_item *vars;
  bool_t execRet;

  int len = obj_length(hargs);
  JHandle **body = unhand(hargs)->body;

  int i;

#if 0
printf("class of the method: %s\n", cbName(fieldclass(&mb->fb)));
fflush(stdout);
#endif
  /* οäƤ뤫å */
#if 0
printf("method: %s, args_size: %d, len: %d\n", mb->fb.name, mb->args_size, len);
fflush(stdout);
#endif
  if ((mb->args_size - (isStaticCall ? 0 : 1)) != len)  goto throw_exc;

#if 0
printf("obj: 0x%x\n", (int)obj);
fflush(stdout);
#endif
  /* null Ф static ǤϤʤ᥽åɤƤǤʤå */
  if (!isStaticCall && !obj)  goto throw_exc;

  /* frame Ѱ */
  oldFrame = ee->current_frame;
  if (isStaticCall) {
    int nlocals = (mb->args_size + ((mb->fb.access & ACC_STATIC)?0:1));
    newFrame = allocNewJavaFrameWithNLocals(mb, ee, nlocals);
  }
  else
    newFrame = allocNewJavaFrame(mb, ee);
	/* native method ǤäƤ frame äƤޤ*/

  vars = newFrame->vars;

  /*  */
  if (!isStaticCall) {
    (vars++)->h = obj;
  }
  for (i = 0; i < len; i++) {
    (vars++)->h = body[i];	/* todo: ܷб */
#if 0
printf("classname of arg %d: %s\n", 
i, cbName(body[i]->methods->classdescriptor));
fflush(stdout);
#endif
  }

  if (isNativeMethod) {
    stack_item *optop;

    ee->current_frame = oldFrame;
    if (java_monitor) {		/* profiling */
      long stime, etime;
      stime = now();
      optop = (*(stack_item * (*) (stack_item *, ExecEnv *)) mb->code)
							(newFrame->vars, ee);
      etime = now();
      java_mon(oldFrame->current_method, mb, etime - stime);
    }
    else {
	optop = (*(stack_item * (*) (stack_item *, ExecEnv *)) mb->code)
							(newFrame->vars, ee);
    }
    /* θǤҤȤ frame ᤹Τ oldFrame->optop = optop  */
  }
  else {
    /* for profiling */
    if (java_monitor)  newFrame->mon_starttime = now();

    execRet = ExecuteJava(mb->code, ee);
  }

  /* todo: ֤ͤ򰷤, ܷ wrap  */

  ee->current_frame = oldFrame;

  return;

throw_exc:
  SignalError(0, "java/lang/IllegalArgumentException", 0);

  return;
}


/*
 * ᥽å̾
 */
extern struct Hjava_lang_String *NET_shudo_moba_reflect_MetaMethod_name(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  char *name = mb->fb.name;

  return makeJavaString(name, strlen(name));
}

/*
 * signature
 */
extern struct Hjava_lang_String *NET_shudo_moba_reflect_MetaMethod_sig(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);

  char * sig = mb->fb.signature;
  return makeJavaString(sig, strlen(sig));
}

/*
 * method ID
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_methodID(struct HNET_shudo_moba_reflect_MetaMethod *_this, struct Hjava_lang_String *hname, struct Hjava_lang_String *hsig) {
  char *name, *sig;
  int id;

  if (!hname || !hsig)  return 0;

  name = makeCString(hname);
  sig = makeCString(hsig);
  id = NameAndTypeToHash(name, sig);	/* uint32_t */

  return *((int32_t *)&id);
}

/*
 * access modifier
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_access(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->fb.access;
}


/*
 * max stack
 */
 extern int32_t NET_shudo_moba_reflect_MetaMethod_maxStack(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->maxstack;
}

/*
 * max locals
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_maxLocals(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->nlocals;
}

/*
 * code length
 */
extern int64_t NET_shudo_moba_reflect_MetaMethod_codeLength(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int64_t)mb->code_length;
}

/*
 * ᥽å catch 㳰ο
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_catchFrameLength(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->exception_table_length;
}

/*
 * ᥽åǤ㳰 catch ˤĤƤξ
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_catchFrameStartPC(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->exception_table_length))  return -1;
  return (int32_t)(mb->exception_table)[index].start_pc;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_catchFrameEndPC(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->exception_table_length))  return -1;
  return (int32_t)(mb->exception_table)[index].end_pc;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_catchFrameHandlerPC(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->exception_table_length))  return -1;
  return (int32_t)(mb->exception_table)[index].handler_pc;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_catchFrameExceptionIndexInCP(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->exception_table_length))  return -1;
  return (int32_t)(mb->exception_table)[index].catchType;
}


/*
 * line no. table
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_lineNoTableLength(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->line_number_table_length;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_lineNoTablePC(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->line_number_table_length))  return -1;
  return (int32_t)(mb->line_number_table)[index].pc;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_lineNoTableLineNo(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->line_number_table_length))  return -1;
  return (int32_t)(mb->line_number_table)[index].line_number;
}


/*
 * local var. table
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTableLength(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->localvar_table_length;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTablePC(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->localvar_table_length))  return -1;
  return (int32_t)(mb->localvar_table)[index].pc0;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTableLife(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->localvar_table_length))  return -1;
  return (int32_t)(mb->localvar_table)[index].length;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTableNameIndex(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->localvar_table_length))  return -1;
  return (int32_t)(mb->localvar_table)[index].nameoff;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTableSigIndex(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->localvar_table_length))  return -1;
  return (int32_t)(mb->localvar_table)[index].sigoff;
}

extern int32_t NET_shudo_moba_reflect_MetaMethod_localVarTableSlot(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->localvar_table_length))  return -1;
  return (int32_t)(mb->localvar_table)[index].slot;
}


/*
 * ᥽åɤ throw 㳰ο
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_thrownExceptionLength(struct HNET_shudo_moba_reflect_MetaMethod *_this) {
#if (JDK_VER < 110)
  return 0;
#else
  struct methodblock *mb = metaMethodToMethodblock(_this);
  return (int32_t)mb->nexceptions;
#endif
}

/*
 * ᥽åɤ throw 㳰ˤĤƤξ
 */
extern int32_t NET_shudo_moba_reflect_MetaMethod_thrownExceptionIndexInCP(struct HNET_shudo_moba_reflect_MetaMethod *_this, int32_t index) {
#if (JDK_VER < 110)
  return -1;
#else
  struct methodblock *mb = metaMethodToMethodblock(_this);
  if ((index < 0) || (index >= mb->nexceptions))  return -1;
  return (int32_t)(mb->exceptions)[index];
#endif
}


/*
 *  ((methodblock *)mb->code) Ϥ롣
 */
extern void NET_shudo_moba_reflect_MetaMethod_writeCode(struct HNET_shudo_moba_reflect_MetaMethod *_this, struct Hjava_io_OutputStream *out) {
  struct methodblock *mb = metaMethodToMethodblock(_this);
  uint32_t length = mb->code_length;
  unsigned char *code = mb->code;

  if ((length <= 0) || !code)  return;

  if ((writeBytes(out, (char *)code, (int)length)) < 0)  goto exc_occurred;

  return;

exc_occurred:
  THROW_IOEXCEPTION();
}



/*
 *	Local Functions
 */

static struct methodblock *metaMethodToMethodblock(HNET_shudo_moba_reflect_MetaMethod *mm) {
  return cbMethods(HMetaClassToClassClass(mm)) + unhand(mm)->index;
}
