/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.net;


import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.util.StringTokenizer;


/**
 * identd ʤɤ Authentication Server (RFC931) 
 * OS̾桼ID 륯饹<BR>
 * UDP ǤϤʤ TCP ѡ
 */
public class SocketAuthenticator {
  private static final String COMMAND = "portident";

  private static final int AUTH_PORT = 113;
	// should get with getservbyname(3)


  private String responce;
  private String OSName;
  private String userID;
  private boolean error = false;


  public SocketAuthenticator(Socket sock) throws IOException {
    this(sock.getInetAddress(), sock.getLocalPort(), sock.getPort());
  }

  public SocketAuthenticator(String host, int localPort, int remotePort)
	throws IOException /* includes UnknownHostException */ {
    this(InetAddress.getByName(host), localPort, remotePort);
  }

  /**
   * Auth. Server  OS̾桼ID 롣<BR>
   * Ԥ IOException  throw 롣<BR>
   * ꤵ줿ݡȤѤƤ桼ʤä
   * SocketAuthenticator#isNoUser() ֤褦ˤʤ롣
   *
   * @see isNoUser()
   */
  public SocketAuthenticator(InetAddress addr, int localPort, int remotePort)
	throws IOException {
    // Auth. Server ³
    Socket authSock;
    authSock = new Socket(addr, AUTH_PORT);	// throws IOException

    // session
    {
      DataOutputStream dout = new DataOutputStream(authSock.getOutputStream());
      DataInputStream din = new DataInputStream(authSock.getInputStream());

      String request = remotePort + ", " + localPort + "\r\n";
//System.out.print("req: " + request);
      dout.writeBytes(request);
      this.responce = din.readLine();
//System.out.println("res: " + responce);
    }	// throws IOException

    // 
    StringTokenizer tokenizer = new StringTokenizer(
	responce.substring(responce.indexOf(':') + 1), " :\t\n\r");
    int numToken = tokenizer.countTokens();
    if (numToken < 2)
      throw new IOException("Illegal responce");

    String[] args = new String[numToken];
    int index = 0;
    while (tokenizer.hasMoreElements()) {
      args[index++] = (String)tokenizer.nextElement();
    }
//for (int i=0; i < args.length; i++)  System.out.print("[" + args[i] + "]");
//System.out.println();

    String resType = args[0].toLowerCase();
    if (resType.equals("userid")) {
//System.out.println("numToken: " + numToken);
//System.out.println("error: " + error);
      if (numToken < 3)
	throw new IOException("Illegal responce");
      OSName = args[1];
      userID = args[2];
    }
    else if (resType.equals("error")) {
      error = true;  return;
    }
    else
      throw new IOException("Illegal responce");
  }


  /**
   * Auth. Server Υ󥹥ݥ󥹤֤
   */
  public String responce() { return responce; }

  /**
   * OS̾ ֤
   */
  public String OSName() { return OSName; }

  /**
   * 桼ID ֤
   */
  public String userID() { return userID; }

  /**
   * 󥹥ȥ饯ǻꤷݡȤѤƤ桼ʤп
   */
  public boolean isNoUser() { return error; }


  private static void usage(String cmd) {
    System.out.print("usage: ");
    System.out.print(cmd);
    System.out.println(" hostname localport remoteport");
  }


  public static void main(String[] args) throws IOException {
    int localPort, remotePort;

    if (args.length < 3) {
      usage(COMMAND);  System.exit(1);
    }

    localPort = Integer.parseInt(args[1]);
    remotePort = Integer.parseInt(args[2]);

    SocketAuthenticator id =
	new SocketAuthenticator(args[0], localPort, remotePort);

    if (id.isNoUser()) {
      System.out.println("Error occurred.");
    }
    else {
      System.out.println("responce: " +id.responce());
      System.out.println("  OS  : " + id.OSName());
      System.out.println("  user: " + id.userID());
    }
  }
}
