/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.io.InputStream;
import java.io.FileInputStream;	// for optimization of throughput
import java.io.OutputStream;	// for negotiateClassDef()
import java.io.DataInputStream;	// for negotiateClassDef()
import java.io.DataOutputStream;// for negotiateClassDef()
import java.io.BufferedInputStream;	// for optimization of throughput
import java.io.BufferedOutputStream;	// for optimization of throughput
import java.io.IOException;
import java.net.Socket;
import java.net.InetAddress;
import java.util.Vector;	// for negotiateClassDef()
import java.util.Enumeration;	// for negotiateClassDef()
import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.lang.PlaceAddress;
import NET.shudo.moba.io.ThreadReader;
import NET.shudo.moba.io.ObjectReader;
import NET.shudo.moba.reflect.MetaClass;	// for negotiateClassDef()


/**
 * ҤȤĤΥåɤ졢ư륯饹<BR>
 * ThreadServer 鵯ư롣
 *
 * @see NET.shudo.moba.place.ThreadServer
 */
public
class ThreadImporter implements Runnable {
  InputStream in;
  OutputStream out;	// optional
  Socket sock;		// optional
  String filename;	// optional
  private boolean debug = false;


  protected ThreadImporter(Socket sock, boolean debug)
	throws IOException {
    this(sock.getInputStream(), sock.getOutputStream(), debug);
    this.sock = sock;
  }
  protected ThreadImporter(String fname, boolean debug)
	throws IOException {
    this(new FileInputStream(fname), null, debug);
    this.filename = fname;
  }
  private ThreadImporter(InputStream in, OutputStream out, boolean debug) {
//    this.in = new BufferedInputStream(in, 32 * 1024);
//    this.out = new BufferedOutputStream(out, 32 * 1024);
    this.in = in;  this.out = out;
    this.debug = debug;
  }


  public void run() {
/* obsolete
    // 饹ΤȤ
    if (this.out != null) {
      try {
	negotiateClassDef(in, out);
      }
      catch (Exception e) {
	success = false;
	if (debug)  e.printStackTrace();
      }
    }
*/

    ObjectReader thrIn = null;
    try {
      thrIn = new ThreadReader(MobaPlace.threadPool, in);
	// attach imported thread to MobaPlace.threadPool
	// this ThreadReader loads classes via network
    }
    catch (IOException e) {
      if (debug)  e.printStackTrace();
    }


    boolean success = true;	// 

    // 饹
    MobaClassLoader loader = null;
    {
      PlaceAddress classSrc = null;
      try {
	if (sock != null)	{	// ThreadExporter ȤȤ
	  try {
	    classSrc = (PlaceAddress)thrIn.readObject();
	  } catch (Exception e) {  if (debug)  e.printStackTrace();  }
	}
	else if (filename != null)
	  classSrc = ThreadReader.generatedPlaceFromFile(filename);
      }
      catch (IOException e) {  if (debug)  e.printStackTrace();  }

      if (classSrc != null) {
	try {
	  loader = MobaClassLoader.get(classSrc);
	  loader.debug(debug);

	  // ȥȤ䤹
	  loader.register();

	  thrIn.classLoader(loader);
	}
	catch (IOException e) {
	  success = false;
	  if (debug)  e.printStackTrace();
	}
      }
    }


    // åɤμ
    MobaThread thread = null;

    if (success) {
      try {
	if (debug)
	  System.out.println("ThreadImporter: now reading a thread..");
	thread = (MobaThread)thrIn.readObject();
      }
      catch (Exception e) {
	success = false;
	if (debug)  e.printStackTrace();
      }
      Logger.log(this, "receipt " + (success?"success":"failed") + ".");
      if (debug)
	System.out.println("ThreadImporter: reading is done (" +
		(success?"success":"failure") + ").");
    }

    // close
    try {
      in.close();
      if (out != null)  out.close();
      if (sock != null)  sock.close();
    }
    catch (IOException e) {  if (debug)  e.printStackTrace();  }

    if (success) {	// 
      // 줿åɤ resume
      thread.resume();
if (debug) {
System.out.println("listing by ThreadImporter (resumed thread):");
(new NET.shudo.moba.util.ThreadLister()).listAllThreads(System.out);
System.out.flush();
}

      // 쥹åɤνλԤ
      boolean joinDone;
      do {
	joinDone = true;
	try {
	  thread.join();
	}
	catch (InterruptedException e) { joinDone = false; }
      } while (!joinDone);

if (debug) {
System.out.println("listing by ThreadImporter (join done):");
(new NET.shudo.moba.util.ThreadLister()).listAllThreads(System.out);
System.out.flush();
}
    }	// if (success)
    else {
if (debug) {
System.out.println("Migration failed.");
System.out.flush();
}
    }


    // 饹λȥȤ򸺤餹
    if (loader != null)  loader.unregister();
  }


  /**
   * ThreadExporter Ȥδ֤ɬפʥ饹ΤȤԤ
   */
  private void negotiateClassDef(
	InputStream sockIn, OutputStream sockOut) throws IOException {
    DataInputStream in = new DataInputStream(sockIn);
    DataOutputStream out = new DataOutputStream(sockOut);

    String[] classes;
    int nClass;
    int i;

    // 饹̾
    nClass = in.readInt();
//System.out.println("nClass is " + nClass);
//System.out.flush();
    classes = new String[nClass];
    for (i = 0; i < nClass; i++) {
      classes[i] = in.readUTF();
//System.out.println("classname `" + classes[i] + "' is caught.");
//System.out.flush();
    }

    // 饹¸ߤ뤫å
    Vector classesNotFound = new Vector();
    for (i = 0; i < nClass; i++) {
      try {
	Class.forName(classes[i]);
      }
      catch (ClassNotFoundException e) {
	classesNotFound.addElement(classes[i]);
	if (debug) {
	  System.out.println("class `" + classes[i] + "' is not found.");
	}
      }
    }

    // 饹̾
    nClass = classesNotFound.size();
    out.writeInt(nClass);
    for (Enumeration e = classesNotFound.elements(); e.hasMoreElements(); ) {
      out.writeUTF((String)e.nextElement());
    }
    out.flush();

    // 饹
    ClassLoader loader = this.getClass().getClassLoader();
	// ŪˤϥåɤȤ̤ ClassLoader ˤ
    if (debug) {
      System.out.println("ClassLoader: " + loader);
    }

    for (i = 0; i < nClass; i++) {
      int classfileLen = in.readInt();
      if (debug)  System.out.println("classfile length: " + classfileLen);

      if (classfileLen > 0) {
	Class definedClass = null;
	byte[] classfile = new byte[classfileLen];
	in.readFully(classfile);

	definedClass =
	  MetaClass.defineClass(loader,
		(String)null, classfile, 0, classfileLen);

	if (debug) {
	  System.out.print("MetaClass#defineClass() returns: ");
	  if (definedClass == null)
	    System.out.println("(null)");
	  else
	    System.out.println(definedClass.getName());
	}
      }
    }
  }
}
