/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.reflect;


/**
 * access modifier ΰ
 */
public final
class Access {
  public static final int PUBLIC	= 0x0001;
	// visible to everyone
  public static final int PRIVATE	= 0x0002;
	// visible only to the defining class
  public static final int PROTECTED	= 0x0004;
	// visible to subclasses
  public static final int STATIC	= 0x0008;
	// instance variable is static
  public static final int FINAL		= 0x0010;
	// no further subclassing, overriding
  public static final int SYNCHRONIZED	= 0x0020;
	// wrap method call in monitor lock
  public static final int SUPER		= 0x0020;
	// funky handling of invokespecial
  public static final int THREADSAFE	= 0x0040;
	// can cache in registers
  public static final int TRANSIENT	= 0x0080;
	// not persistant
  public static final int NATIVE	= 0x0100;
	// implemented in C
  public static final int INTERFACE	= 0x0200;
	// class is an interface
  public static final int ABSTRACT	= 0x0400;
	// no definition provided
  public static final int XXUNUSED1	= 0x0800;

  public static final int WRITTEN_FLAGS	= 0x0FFF;
	// flags actually put in .class file


  // Other attributes
  public static final int VALKNOWN	= 0x1000;
	// constant with known value
  public static final int DOCED		= 0x2000;
	// documentation generated
  public static final int MACHINE_COMPILED = 0x4000;
	// compiled to machine code
  public static final int XXUNUSED3	= 0x8000;


  /**
   * 饹ե˽Ϥʤʬޥ롣
   */
  public static int maskInClassfile(int acc) {
    return (acc & WRITTEN_FLAGS);
  }


  public static boolean isPublic(int acc) { return (acc & PUBLIC) != 0; }
  public static boolean isPrivate(int acc) { return (acc & PRIVATE) != 0; }
  public static boolean isProtected(int acc) { return (acc & PROTECTED) != 0; }
  public static boolean isStatic(int acc) { return (acc & STATIC) != 0; }
  public static boolean isFinal(int acc) { return (acc & FINAL) != 0; }
  public static boolean isSynchronized(int acc) { return (acc & SYNCHRONIZED) != 0; }
  public static boolean isSuper(int acc) { return (acc & SUPER) != 0; }
  public static boolean isThreadsafe(int acc) { return (acc & THREADSAFE) != 0; }
  public static boolean isTransient(int acc) { return (acc & TRANSIENT) != 0; }
  public static boolean isNative(int acc) { return (acc & NATIVE) != 0; }
  public static boolean isInterface(int acc) { return (acc & INTERFACE) != 0; }
  public static boolean isAbstract	(int acc) { return (acc & ABSTRACT) != 0; }
  public static boolean isXxunused1(int acc) { return (acc & XXUNUSED1) != 0; }

  public static boolean isValknown(int acc) { return (acc & VALKNOWN) != 0; }
  public static boolean isDoced(int acc) { return (acc & DOCED) != 0; }
  public static boolean isMachineCompiled(int acc) { return (acc & MACHINE_COMPILED) != 0; }
  public static boolean isXxunused3(int acc) { return (acc & XXUNUSED3) != 0; }
}
