/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.reflect;

public
class MetaField {
  private Class thisClass;
  private MetaClass thisMetaClass;
  private int index;	// field number
  private String thisSig;

  protected MetaField(MetaClass thisMetaClass, int index) {
    this.thisMetaClass = thisMetaClass;
    this.thisClass = thisMetaClass.classClass();
    this.index = index;
    this.thisSig = sig();	// call native method
  }

  public String toString() {
    StringBuffer buf = new StringBuffer();

    buf.append(name());
    buf.append('{');
    buf.append(signature());
    buf.append('}');

    return buf.toString();
  }

  public MetaClass thisClass() { return this.thisMetaClass; }

  public native String name();
  public String signature() { return thisSig; }
  private native String sig();
  public native int access();

  /**
   * ΥեɤΥ饹롣
   *
   * @return Υեɤ֥ȤǤʤnull
   */
  public Class classOfField() {
    Class ret = null;
    if (!isObject())  return null;
    try {
      ret = MetaClass.classBySignature(signature(), null);
    }
    catch (ClassNotFoundException e) {
      // not reached
      e.printStackTrace();
    }
    return ret;
  }

  public native boolean isAccessible();

  public boolean isArray() {  return Signature.isArray(signature());  }
  public boolean isObject() {  return Signature.isObject(signature());  }
  public boolean isObjectArray() {  return Signature.isObjectArray(signature());  }
  public boolean isBaseTypeArray() {  return Signature.isBaseTypeArray(signature());  }

  public boolean isAny() {
    return Signature.isAny(signature());
  }
  public boolean isByte() {
    return Signature.isByte(signature());
  }
  public boolean isChar() {
    return Signature.isChar(signature());
  }
  public boolean isDouble() {
    return Signature.isDouble(signature());
  }
  public boolean isEnum() {
    return Signature.isEnum(signature());
  }
  public boolean isFloat() {
    return Signature.isFloat(signature());
  }
  public boolean isInt() {
    return Signature.isInt(signature());
  }
  public boolean isLong() {
    return Signature.isLong(signature());
  }
  public boolean isShort() {
    return Signature.isShort(signature());
  }
  public boolean isVoid() {
    return Signature.isVoid(signature());
  }
  public boolean isBoolean() {
    return Signature.isBoolean(signature());
  }

  public native boolean isValueNull(Object obj);

  // եɤͤ
  public native byte getByteValue(Object obj);
  public native char getCharValue(Object obj);
  public native double getDoubleValue(Object obj);
  public native float getFloatValue(Object obj);
  public native int getIntValue(Object obj);
  public native long getLongValue(Object obj);
  public native short getShortValue(Object obj);
  public native boolean getBooleanValue(Object obj);
  public native Object getObjectValue(Object obj);

  // եɤͤ򥻥å
  public native void setByteValue(Object obj, byte val);
  public native void setCharValue(Object obj, char val);
  public native void setDoubleValue(Object obj, double val);
  public native void setFloatValue(Object obj, float val);
  public native void setIntValue(Object obj, int val);
  public native void setLongValue(Object obj, long val);
  public native void setShortValue(Object obj, short val);
  public native void setBooleanValue(Object obj, boolean val);
  public native void setObjectValue(Object obj, Object val);
}
