/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.reflect;

import java.io.OutputStream;	// for writeCode()


public
class MetaMethod {
  private Class thisClass;
  private int index;	// method number

  protected MetaMethod(Class thisClass, int index) {
    this.thisClass = thisClass;
    this.index = index;
    this.thisSig = sig();	// call native method
    this.methodID = methodID(name(), thisSig);
  }

  public native void invoke(Object obj, Object[] args)
	throws IllegalArgumentException;

  public native String name();

  private String thisSig;
  public String signature() { return thisSig; }
  private native String sig();

  private int methodID;
  public int hashCode() { return methodID; }
  public int ID() { return methodID; }
  protected static native int methodID(String name, String sig);

  public native int access();

  public native int maxStack();
  public native int maxLocals();
  public native long codeLength();

  public native void writeCode(OutputStream out);

  public native int catchFrameLength();
  public native int catchFrameStartPC(int CFIndex);
  public native int catchFrameEndPC(int CFIndex);
  public native int catchFrameHandlerPC(int CFIndex);
  public native int catchFrameExceptionIndexInCP(int CFIndex);

  public native int lineNoTableLength();
  public native int lineNoTablePC(int index);
  public native int lineNoTableLineNo(int index);

  public native int localVarTableLength();
  public native int localVarTablePC(int index);
  public native int localVarTableLife(int index);
  public native int localVarTableNameIndex(int index);
  public native int localVarTableSigIndex(int index);
  public native int localVarTableSlot(int index);

  public native int thrownExceptionLength();
  public native int thrownExceptionIndexInCP(int index);
}
